Unit de91e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE90E_p, UTDE21_p;

procedure de91e(F :Proc_FE_DE; FJ :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; XK :Extended; HMIN :Extended;
                EPS :Extended; P :Extended; var H :Extended;
                var Y :Array of Extended; var R :Array of Extended;
                var IERR :Integer);

implementation

procedure de91e(F :Proc_FE_DE; FJ :Proc_FE_DE; M :Integer; XN :Extended;
                var YN :Array of Extended; XK :Extended; HMIN :Extended;
                EPS :Extended; P :Extended; var H :Extended;
                var Y :Array of Extended; var R :Array of Extended;
                var IERR :Integer);
var
JSTART,I,I1,I2,I3,I4,I5,I6,I7 :Integer;
X,H1,HS :Extended;
BUL :Boolean;
label
_10,_20,_5,_30,_40;
begin
for I:=1 to M do
 begin
_10:
  Y[I-1] := YN[I-1];
 end;
X := XN;
if ( XK = X ) 
 then goto _40;
H := Sign(H,XK-X);
BUL := False;
JSTART := 0;
I := M*M;
I1 := 2 + M;
I2 := I1 + I;
I3 := I2 + I;
I4 := I3 + I;
I5 := I4 + 4*M;
I6 := I5 + M;
I7 := I6 + M;
_20:
if ( not BUL ) 
 then goto _5;
H := HS;
goto _40;
_5:
H1 := XK - X;
if ( Abs(H1) > Abs(H) ) 
 then goto _30;
HS := H;
H := H1;
BUL := True;
_30:
DE90E (F,FJ,M,JSTART,HMIN,EPS,P,Y,X,H,BUL,R[0],R[1],R[I1-1],
     R[I2-1],R[I3-1],R[I4-1],R[I5-1],R[I6-1],R[I7-1],IERR);
if ( IERR = 0 ) 
 then goto _20;
UTDE21 (91,IERR);
_40:
end;

end.
